package cfg_test

import (
	"testing"

	"github.com/stretchr/testify/assert"
	"tuxpa.in/t/wm/src/bsp/cfg"
)

type E int

const (
	D0 E = 0
	D1
)

type s1 struct {
	A *int    `cfg:"a" default:"4"`
	B *bool   `cfg:"b"`
	C *string `cfg:"c" default:"crabs"`
	D *E      `cfg:"d"`
}

func TestModifierS1(t *testing.T) {
	s := &s1{}
	m := cfg.NewModifier(s)

	m.Set("b", "on")
	assert.EqualValues(t, *m.Ref.B, true)
	assert.Nil(t, m.Ref.D)
	m.Set("d", "442")
	assert.EqualValues(t, *m.Ref.D, 442)

	m.FillDefaults()
	assert.EqualValues(t, *m.Ref.C, "crabs")

}
