package bsp

type AUTOMATIC_SCHEME_T int

const (
	SCHEME_LONGEST_SIDE AUTOMATIC_SCHEME_T = iota
	SCHEME_ALTERNATE
	SCHEME_SPIRAL
)

type HONOR_SIZE_HINTS_MODE_T int

const (
	HONOR_SIZE_HINTS_NO HONOR_SIZE_HINTS_MODE_T = iota
	HONOR_SIZE_HINTS_YES
	HONOR_SIZE_HINTS_FLOATING
	HONOR_SIZE_HINTS_TILED
	HONOR_SIZE_HINTS_DEFAULT
)

type TIGHTNESS_T int

const (
	TIGHTNESS_LOW TIGHTNESS_T = iota
	TIGHTNESS_HIGH
)

type CHILD_POLARITY_T int

const (
	FIRST_CHILD CHILD_POLARITY_T = iota
	SECOND_CHILD
)

type Config struct {

	// pointer options
	PointerAction1 *string `cfg:"pointer_action1"`
	PointerAction2 *string `cfg:"pointer_action2"`
	PointerAction3 *string `cfg:"pointer_action3"`

	PointerFollowsMonitor *bool   `cfg:"pointer_follows_monitor"`
	FocusFollowsPointer   *bool   `cfg:"focus_follows_pointer"`
	PointerFollowsFocus   *bool   `cfg:"pointer_follows_focus"`
	PointerMotionInterval *string `cfg:"pointer_motion_interval"`

	// control
	PointerModifier      *string `cfg:"pointer_modifier" default:"XCB_MOD_MASK_4"`
	StatusPrefix         *string `cfg:"status_prefix" default:"W"`
	ExternalRulesCommand *string `cfg:"external_rules_command" default:""`

	// click
	ClickToFocus      *string `cfg:"click_to_focus" default:"XCB_BUTTON_INDEX_1"`
	SwallowFirstClick *bool   `cfg:"swallow_first_click"`

	// ewmh
	IgnoreEwmhFocus      *bool `cfg:"ignore_ewmh_focus"`
	IgnoreEwmhFullscreen *bool `cfg:"ignore_ewmh_fullscreen"`
	IgnoreEwmhStruts     *bool `cfg:"ignore_ewmh_struts"`

	// monocole
	PreselFeedback    *bool `cfg:"presel_feedback" default:"true"`
	GaplessMonocle    *bool `cfg:"gapless_monocle"`
	BorderlessMonocle *bool `cfg:"borderless_monocle"`
	SingleMonocle     *bool `cfg:"single_monocle"`

	// padding
	TopPadding    *int `cfg:"top_padding"`
	BottomPadding *int `cfg:"bottom_padding"`
	LeftPadding   *int `cfg:"left_padding"`
	RightPadding  *int `cfg:"right_padding"`

	// monocle padding
	TopMonoclePadding    *int `cfg:"top_monocle_padding"`
	BottomMonoclePadding *int `cfg:"bottom_monocle_padding"`
	LeftMonoclePadding   *int `cfg:"left_monocle_padding"`
	RightMonoclePadding  *int `cfg:"right_monocle_padding"`

	// splits
	SplitRatio        *float64            `cfg:"split_ratio" default:"0.5"`
	AutomaticScheme   *AUTOMATIC_SCHEME_T `cfg:"automatic_scheme"`
	RemovalAdjustment *string             `cfg:"removal_adjustment"`

	// gap
	WindowGap           *int  `cfg:"window_gap"`
	BorderWidth         *int  `cfg:"border_width"`
	BorderlessSingleton *bool `cfg:"borderless_singleton"`

	//colors
	ActiveBorderColor   *ColorCode `cfg:"active_border_color"`
	PreselFeedbackColor *ColorCode `cfg:"presel_feedback_color"`
	FocusedBorderColor  *ColorCode `cfg:"focused_border_color"`
	NormalBorderColor   *ColorCode `cfg:"normal_border_color"`

	//monitor
	RemoveDisabledMonitors   *bool `cfg:"remove_disabled_monitors"`
	RemoveUnpluggedMonitors  *bool `cfg:"remove_unplugged_monitors"`
	MergeOverlappingMonitors *bool `cfg:"merge_overlapping_monitors"`

	// more
	CenterPseudoTiled  *bool                    `cfg:"center_pseudo_tiled" default:"true"`
	HonorSizeHints     *HONOR_SIZE_HINTS_MODE_T `cfg:"honor_size_hints"`
	MappingEventsCount *int                     `cfg:"mapping_events_count" default:"1"`

	//etc
	DirectionalFocusTightness *TIGHTNESS_T      `cfg:"directional_focus_tightness"`
	InitialPolarity           *CHILD_POLARITY_T `cfg:"initial_polarity"`
}
